package nc.bs.gl.reconcileufo;

import java.io.Serializable;
import java.util.Vector;
import nc.bs.logging.Logger;
import nc.ui.gl.reconcileufo.ContrastUFOFunc;
import nc.vo.fi.uforeport.IFuncNCBatch;
import nc.vo.fi.uforeport.ResultVO;
import nc.vo.fi.uforeport.UfoParseException;
import nc.vo.fi.uforeport.UfoSimpleObject;
import nc.vo.ml.NCLangRes4VoTransl;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pub.util.StringUtil;

public class SrvCallNCGR implements IFuncNCBatch, Serializable {

   private static final long serialVersionUID = 121212121L;


   public ResultVO[] callFunc(String[] strFuncName, String[] strParam) throws Exception {
      if(strFuncName != null && strFuncName.length != 0) {
         Vector v = new Vector();
         ResultVO[] retvos = null;

         for(int m = 0; m < strFuncName.length; ++m) {
            Object rtnvalue;
            ResultVO vo;
            if(strFuncName[m] != null && (strFuncName[m].equalsIgnoreCase("GRDZDF") || strFuncName[m].equalsIgnoreCase("DZDF"))) {
               rtnvalue = this.callFunc((String)strFuncName[m], (String)strParam[m]);
               vo = new ResultVO();
               vo.setFuncName(strFuncName[m]);
               vo.setParams(strParam[m]);
               vo.setValue(rtnvalue);
               v.addElement(vo);
            }

            if(strFuncName[m] != null && (strFuncName[m].equalsIgnoreCase("GRXTJE") || strFuncName[m].equalsIgnoreCase("XTJE"))) {
               rtnvalue = this.callFunc((String)strFuncName[m], (String)strParam[m]);
               vo = new ResultVO();
               vo.setFuncName(strFuncName[m]);
               vo.setParams(strParam[m]);
               vo.setValue(rtnvalue);
               v.addElement(vo);
            }
         }

         if(v.size() > 0) {
            retvos = new ResultVO[v.size()];
            v.copyInto(retvos);
         }

         return retvos;
      } else {
         return null;
      }
   }

   public Object callFunc(String strFuncName, String strParam) throws Exception {
      Logger.debug("+++++++++++++++++++++++++++++++++++");
      Logger.debug("_-------------进入总帐处理，单个公式处理-----------");
      Logger.debug("+++++++++++++++++++++++++++++++++++");
      strFuncName = StringUtil.replaceAllString(strFuncName.toUpperCase(), "GL", "");
      strParam = StringUtil.replaceAllString(strParam, "\r\n", ",");
      UFDouble retv = new UFDouble("0");
      ContrastUFOFunc e;
      if(!strFuncName.equalsIgnoreCase("GRDZDF") && !strFuncName.equalsIgnoreCase("DZDF")) {
         if(strFuncName.equalsIgnoreCase("GRXTJE") || strFuncName.equalsIgnoreCase("XTJE")) {
            try {
               e = new ContrastUFOFunc();
               retv = e.reconcileGRXTJE(strParam);
            } catch (Exception var6) {
               retv = new UFDouble(0);
               Logger.debug("总账协同金额取数异常！");
               var6.printStackTrace();
            }
         }
      } else {
         try {
            e = new ContrastUFOFunc();
            retv = e.contrastGRDZDF(strParam);
         } catch (Exception var7) {
            retv = new UFDouble(0);
            Logger.debug("总账对帐对符取数异常！");
            var7.printStackTrace();
         }
      }

      if(retv == null) {
         return new Double(0.0D);
      } else {
         Logger.debug("*******************  总帐单公式处理输出,共有输出   ***************");
         Logger.debug("**************************************");
         Logger.debug(strFuncName + "(" + strParam + ")-----return value:" + retv.toString());
         Logger.debug("**************************************");
         return new Double(retv.doubleValue());
      }
   }

   public String[] checkFunc(String[] strFuncName, String[] strParam) throws UfoParseException, Exception {
      return null;
   }

   public String checkFunc(String strFuncName, String strParam) throws UfoParseException, Exception {
      return null;
   }

   public String doFuncRefer(String strFuncName) {
      return null;
   }

   public boolean getDefaultParaFlag() {
      return true;
   }

   public int getFuncCount(int iServPos) {
      return 2;
   }

   public String getFuncDesc(String strFuncName) {
      return strFuncName.equalsIgnoreCase("GRDZDF")?NCLangRes4VoTransl.getNCLangRes().getStrByID("20021505", "UPP20021505-000520"):(strFuncName.equalsIgnoreCase("GRXTJE")?NCLangRes4VoTransl.getNCLangRes().getStrByID("20021505", "UPP20021505-000521"):"test @@@@");
   }

   public String getFuncForm(String strFuncName) {
      return strFuncName.equalsIgnoreCase("GRDZDF")?NCLangRes4VoTransl.getNCLangRes().getStrByID("20021505", "UPP20021505-000493"):(strFuncName.equalsIgnoreCase("GRXTJE")?NCLangRes4VoTransl.getNCLangRes().getStrByID("20021505", "UPP20021505-000494"):null);
   }

   public UfoSimpleObject[] getFuncList(int iModulePos) {
      UfoSimpleObject[] funcList = new UfoSimpleObject[]{new UfoSimpleObject(), null};
      funcList[0].setID(0);
      funcList[0].setName("GRDZDF");
      funcList[1] = new UfoSimpleObject();
      funcList[1].setID(1);
      funcList[1].setName("GRXTJE");
      return funcList;
   }

   public String getFuncName(int iModulePos, int iFuncPos, String[] strChName) {
      return iFuncPos == 0?"GRDZDF":(iFuncPos == 1?"GRXTJE":null);
   }

   public byte getFuncType(String strFuncName) {
      return (byte)2;
   }

   public int getModuleCount() {
      return 1;
   }

   public String getModuleDesc(int iPos) {
      return NCLangRes4VoTransl.getNCLangRes().getStrByID("200213", "UPP200213-000615");
   }

   public UfoSimpleObject[] getModuleList() {
      UfoSimpleObject[] m_moduleList = new UfoSimpleObject[]{new UfoSimpleObject()};
      m_moduleList[0].setID(1200);
      m_moduleList[0].setName(NCLangRes4VoTransl.getNCLangRes().getStrByID("200213", "UPP200213-000616"));
      return m_moduleList;
   }

   public int getVersion() {
      return 0;
   }

   public boolean hasReferDlg(String strFuncName) {
      return true;
   }

   public boolean isModuleFunc(String strFuncName) {
      return strFuncName.equalsIgnoreCase("GRDZDF")?true:strFuncName.equalsIgnoreCase("GRXTJE");
   }

   public String setCalEnv(String[] env) {
      return null;
   }

   public boolean setDefaultPara() {
      return false;
   }

   public static void main(String[] args) {
   }

   public boolean isTranslate(String sFuncName) {
      return false;
   }
}
